今天是贪心算法的第4天,开冲!!!
今日任务:
- 860.柠檬水找零
- 406.根据身高重建队列
- 452.用最少数量的箭引爆气球
题目一:860.柠檬水找零
Leetcode题目:【860.柠檬水找零】
参考:【代码随想录之柠檬水找零】
这其实是一个非常简单的模拟题,贪心的策略是对于20这种的 优先用掉10+5这种情况,然后遍历整个数组,分别从5\10\20进行讨论。
class Solution {
public:
bool lemonadeChange(vector<int>& bills) {
int five = 0, ten = 0;
for(int i = 0; i<bills.size(); i++){
if(bills[i] == 5) five++;
if(bills[i] == 10){
if(five <= 0) return false;
ten++;
five--;
}
if(bills[i] == 20){
if(five>0 && ten>0){
five--;
ten--;
}else if(five >= 3){
five = five - 3;
}else{
return false;
}
}
}
return true;
}
};
题目二:406.根据身高重建队列(困难)
Leetcode题目:【406.根据身高重建队列】
参考:【代码随想录之根据身高重建队列】
已经猪脑过载,根本想不到这个巧妙的思路了!!!
这个题目需要先确定身高这个维度,然后再确定前面到底有几人,因为已经按身高排好了,只需要按照后面有几个人去排列就好了。
因为此题是有两个维度的,身高和顺序,本地究竟先按照k排序还是h排序:先按h排序,再按k排序进行插入。
局部最优:优先按身高高的people的k来插入。插入操作过后的people满足队列属性
全局最优:最后都做完插入操作,整个队列满足题目队列属性
原始的序列:people = [[7,0],[4,4],[7,1],[5,0],[6,1],[5,2]]
排序完的people: [[7,0], [7,1], [6,1], [5,0], [5,2],[4,4]]
插入的过程:
插入[7,0]:[[7,0]]
插入[7,1]:[[7,0],[7,1]]
插入[6,1]:[[7,0],[6,1],[7,1]]
插入[5,0]:[[5,0],[7,0],[6,1],[7,1]]
插入[5,2]:[[5,0],[7,0],[5,2],[6,1],[7,1]]
插入[4,4]:[[5,0],[7,0],[5,2],[6,1],[4,4],[7,1]]
而且此代码是对二维数组进行排序,sort函数要写的话需要注意
class Solution {
public:
static bool cmp(vector<int>&x, vector<int> & y){
if(x[0] == y[0]) return x[1] < y[1];
return x[0] > y[0];
}
vector<vector<int>> reconstructQueue(vector<vector<int>>& people) {
sort(people.begin(), people.end(), cmp);
vector<vector<int>> que;
for(int i = 0; i<people.size(); i++){
int position = people[i][1];
que.insert(que.begin() + position, people[i]);
}
return que;
}
};
题目三:452.用最少数量的箭引爆气球(困难)
Leetcode题目:【452.用最少数量的箭引爆气球】
参考:【代码随想录之用最少数量的箭引爆气球】
这么巧妙的思路,我这个猪脑根本想不到,主要分为两个步骤:
(1)对左节点进行排序,依次会有一个空间图;
(2)动态更新右节点;
一定不重叠的情况为前一个右节点 < 下一个的左节点,一定是需要一个弓箭的,对于能不能把下面的带上,需要看更新的右节点的值
class Solution {
public:
static bool cmp(vector<int>&x, vector<int>&y){
return x[0] < y[0];
}
int findMinArrowShots(vector<vector<int>>& points) {
sort(points.begin(), points.end(), cmp);
int result = 1;
// for(int i = 0; i<points.size(); i++){
// cout << points[i][0] << ", " << points[i][1]<< endl;
// }
for(int i = 1; i<points.size(); i++){
if(points[i][0] > points[i-1][1]){
result++;
}else{
points[i][1] = min(points[i][1], points[i-1][1]);
}
}
return result;
}
};